export declare type GeoJSONPoint = {
    type: 'Point';
    coordinates: [number, number];
};
export declare function makeGeoJsonPoint(lon: number, lat: number): GeoJSONPoint;
export declare function isGeoJsonPoint(value: any): value is GeoJSONPoint;
export declare type WKTPoint = string;
export declare function isWKTPoint(value: string): value is WKTPoint;
export declare type GeoPoint = {
    lon: number;
    lat: number;
};
export declare function makeGeoPoint(lon: number, lat: number): GeoPoint;
export declare function makeGeoPointFromWKT(point: WKTPoint): GeoPoint;
export declare function makeGeoPointFromGeoJSON(point: GeoJSONPoint): GeoPoint;
export declare function makeGeoPointFromPojo(point: {
    lon: number;
    lat: number;
}): GeoPoint;
export declare function isGeoPoint(value: any): value is GeoPoint;
export declare type GeoPolygon = GeoPoint[];
export declare function makeGeoPolygon(...points: GeoPoint[]): GeoPolygon;
export declare function calculateDistance(from: GeoPoint, to: GeoPoint): number;
export declare function intersects(point: GeoPoint, polygon: GeoPolygon): boolean;
