export declare function isIterable<T>(source: any): source is Iterable<T>;
export declare type Sortable = string | number | Date;
export declare type SortStrategy<T> = (left: T, right: T) => -1 | 0 | 1;
declare function ascendingSortStrategy(l: Sortable, r: Sortable): -1 | 0 | 1;
declare function descendingSortStrategy(l: Sortable, r: Sortable): -1 | 0 | 1;
export declare function sortBy<T>(selector: (value: T) => Sortable, strategy?: SortStrategy<Sortable>): (left: T, right: T) => 0 | 1 | -1;
export declare namespace sortBy {
    var asc: typeof ascendingSortStrategy;
    var desc: typeof descendingSortStrategy;
}
export declare function groupBy<T, K>(source: T[], keySelector: (value: T) => K): {
    key: K;
    results: T[];
}[];
export declare function groupBy<T, K, R>(source: T[], keySelector: (value: T) => K, resultSelector: (value: T) => R): {
    key: K;
    results: R[];
}[];
export declare function uniq<T>(source: T[]): T[];
export declare function uniq<T, K, R = T>(source: T[], keySelector: (value: T) => K, valueSelector?: (value: T) => R): R[];
declare const joinSkip: unique symbol;
export declare function join<L, R, Result, LK = keyof L, RK = keyof R>(left: L[], right: R[], leftKeySelector: (v: L) => LK, rightKeySelector: (v: R) => RK, resultSelector: (l: L | null, r: R | null) => (Result | typeof join.skip)): Result[];
export declare namespace join {
    var skip: typeof joinSkip;
}
export declare function distribute<T>(source: Iterable<T>, buckets: 1): [T][];
export declare function distribute<T>(source: Iterable<T>, buckets: 2): [T, T?][];
export declare function distribute<T>(source: Iterable<T>, buckets: 3): [T, T?, T?][];
export declare function distribute<T>(source: Iterable<T>, buckets: 4): [T, T?, T?, T?][];
export declare function sum(source: Iterable<number>): number;
export declare function average(source: Iterable<number>): number;
export declare function min(source: Iterable<number>): number;
export declare function max(source: Iterable<number>): number;
export {};
