import { FilterActions } from './query-filter';
import { OrderByActions } from './query-orderby';
import { SelectActions } from './query-select';
import { SimpleActions } from './query-simple';
import deepmerge from 'deepmerge';
import type { FacetActions, FacetAst, FilterAst, OrderByAst, SelectAst, SimpleAst } from './asts';
export declare type DeepMergeExtendedOptions = deepmerge.Options & {
    isMergeableObject(value: unknown): boolean;
    cloneUnlessOtherwiseSpecified(value: unknown, options: deepmerge.Options): unknown;
};
export declare type MergeSequenceFunction = (target: unknown[], source: unknown[], options: DeepMergeExtendedOptions) => unknown[];
export declare type Parser<R, Args extends unknown[] = []> = {
    parse: (input: string, ...args: Args) => R;
};
export declare type SelectParserResult = SelectAst & SelectActions;
export declare type SelectParser = Parser<SelectParserResult>;
export declare const select: SelectParser;
export declare type SearchParserResult = SelectAst & SelectActions;
export declare type SearchParser = Parser<SearchParserResult>;
export declare const search: SearchParser;
export declare type FilterParserResult = FilterAst & FilterActions;
export declare type FilterParser = Parser<FilterParserResult>;
export declare const filter: FilterParser;
export declare type OrderByParserResult = OrderByAst & OrderByActions;
export declare type OrderByParser = Parser<OrderByParserResult>;
export declare const orderBy: OrderByParser;
export declare type HighlighParserResult = SelectAst & SelectActions;
export declare type HighlighParser = Parser<HighlighParserResult>;
export declare const highlight: HighlighParser;
export declare type FacetParserResult = FacetAst & FacetActions;
export declare type FacetParser = Parser<FacetParserResult>;
export declare const facet: FacetParser;
export declare type SimpleParserResult = SimpleAst & SimpleActions;
export declare type SimpleParser = Parser<SimpleParserResult, [searchMode: 'any' | 'all']>;
export declare const simple: SimpleParser;
