import type { Suggester } from './suggestEngine';
import type { AutocompleteResult } from './searchBackend';
import { SearchBackend } from './searchBackend';
import { PlainAnalysisMode } from './analyzerService';
export interface AutoCompleteRequest {
    autocompleteMode?: PlainAnalysisMode;
    filter?: string;
    fuzzy?: boolean;
    highlightPreTag?: string;
    highlightPostTag?: string;
    minimumCoverage?: number;
    search: string;
    searchFields?: string;
    suggesterName: string;
    top?: number;
}
export interface AutoCompleteDocumentResult {
    '@search.coverage'?: number;
    value: AutocompleteResult[];
}
export declare class AutocompleteEngine<T extends object> {
    private readonly backend;
    private readonly suggesterProvider;
    constructor(backend: SearchBackend<T>, suggesterProvider: (name: string) => Suggester);
    autocomplete(request: AutoCompleteRequest): AutoCompleteDocumentResult;
}
