import type { ODataSelect } from '../../../lib/odata';
import type { Searchable } from '../../schema';
import { SchemaService } from '../../schema';
import type { DocumentMiddleware } from '../../searchBackend';
import { AnalyzedValueFullText, PlainAnalysisMode, QueryAnalyzisResult, QueryingStrategy, SimpleMatches } from '../../analyzerService';
export declare type AnalyzedSearchable = Searchable & QueryAnalyzisResult;
export declare type SuggestionStrategy<T extends object> = (schemaService: SchemaService<T>) => (searchable: AnalyzedSearchable) => (suggestionsAccumulator: unknown[], analyzed: AnalyzedValueFullText, entryMatch: SimpleMatches, entryIndex: number) => void;
export declare function useLuceneSearch<T extends object, Keys extends ODataSelect<T>>(options: {
    searchFields: string;
    queryingStrategy: QueryingStrategy;
    suggestionStrategy: SuggestionStrategy<T>;
}): DocumentMiddleware<T, Keys>;
export declare function createHighlightSuggestionStrategy<T extends object>(options: {
    highlight: string;
    preTag: string;
    postTag: string;
    maxPadding: number;
}): SuggestionStrategy<T>;
export declare function createReplacementSuggestionStrategy<T extends object>(options: {
    highlight: string;
    preTag: string;
    postTag: string;
}): SuggestionStrategy<T>;
export declare function createAutocompleteSuggestionStrategy<T extends object>(options: {
    search: string;
    highlight: string;
    preTag: string;
    postTag: string;
    mode: PlainAnalysisMode;
}): SuggestionStrategy<T>;
