import type { ODataSelect, ODataSelectResult } from '../lib/odata';
import type { SearchFacetBase, SearchResult } from './searchBackend';
import { SearchBackend } from './searchBackend';
import { Scorer } from './scorer';
export interface SearchDocumentsRequest<T extends object, Keys extends ODataSelect<T> | string> {
    count?: boolean;
    facets?: string[];
    filter?: string;
    highlight?: string;
    highlightPreTag?: string;
    highlightPostTag?: string;
    minimumCoverage?: number;
    orderBy?: string;
    queryType?: 'simple' | 'full';
    scoringParameters?: string[];
    scoringProfile?: string;
    scoringStatistics?: 'local' | 'global';
    search?: string;
    searchFields?: string;
    searchMode?: 'any' | 'all';
    select?: Keys[];
    skip?: number;
    top?: number;
}
export interface SearchDocumentsPageResult<T extends object> {
    '@odata.count'?: number;
    '@search.coverage'?: number;
    '@search.facets'?: Record<string, SearchFacetBase[]>;
    '@search.nextPageParameters'?: SearchDocumentsRequest<T, string>;
    value: SearchResult<T>[];
    '@odata.nextLink'?: string;
}
export declare class SearchEngine<T extends object> {
    private readonly backend;
    private readonly scorer;
    constructor(backend: SearchBackend<T>, scorer: Scorer<T>);
    search<Keys extends ODataSelect<T>>(request: SearchDocumentsRequest<T, Keys>): SearchDocumentsPageResult<ODataSelectResult<T, Keys>>;
}
