import type { ODataSelect, ODataSelectResult } from '../lib/odata';
import type { KeyFieldDefinition } from './schema';
import type { SuggestResult } from './searchBackend';
import { SearchBackend } from './searchBackend';
export interface SuggestRequest<T extends object, Keys extends ODataSelect<T> | string> {
    filter?: string;
    fuzzy?: boolean;
    highlightPreTag?: string;
    highlightPostTag?: string;
    minimumCoverage?: number;
    orderBy?: string;
    search: string;
    searchFields?: string;
    select?: Keys[];
    suggesterName: string;
    top?: number;
}
export interface SuggestDocumentsResult<T extends object> {
    '@search.coverage'?: number;
    value: SuggestResult<T>[];
}
export interface Suggester {
    name: string;
    searchMode: 'analyzingInfixMatching';
    fields: string[];
}
export declare class SuggestEngine<T extends object> {
    private backend;
    private keyFieldProvider;
    private suggesterProvider;
    constructor(backend: SearchBackend<T>, keyFieldProvider: () => KeyFieldDefinition, suggesterProvider: (name: string) => Suggester);
    suggest<Keys extends ODataSelect<T>>(request: SuggestRequest<T, Keys>): SuggestDocumentsResult<ODataSelectResult<T, Keys>>;
}
